<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRoomPriceRes ArrayType
 * @subpackage Arrays
 */
class ArrayOfRoomPriceRes extends AbstractStructArrayBase
{
    /**
     * The Room
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RoomPriceRes[]
     */
    public $Room;
    /**
     * Constructor method for ArrayOfRoomPriceRes
     * @uses ArrayOfRoomPriceRes::setRoom()
     * @param \StructType\RoomPriceRes[] $room
     */
    public function __construct(array $room = array())
    {
        $this
            ->setRoom($room);
    }
    /**
     * Get Room value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RoomPriceRes[]|null
     */
    public function getRoom()
    {
        return isset($this->Room) ? $this->Room : null;
    }
    /**
     * Set Room value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RoomPriceRes[] $room
     * @return \ArrayType\ArrayOfRoomPriceRes
     */
    public function setRoom(array $room = array())
    {
        foreach ($room as $arrayOfRoomPriceResRoomItem) {
            // validation for constraint: itemType
            if (!$arrayOfRoomPriceResRoomItem instanceof \StructType\RoomPriceRes) {
                throw new \InvalidArgumentException(sprintf('The Room property can only contain items of \StructType\RoomPriceRes, "%s" given', is_object($arrayOfRoomPriceResRoomItem) ? get_class($arrayOfRoomPriceResRoomItem) : gettype($arrayOfRoomPriceResRoomItem)), __LINE__);
            }
        }
        if (is_null($room) || (is_array($room) && empty($room))) {
            unset($this->Room);
        } else {
            $this->Room = $room;
        }
        return $this;
    }
    /**
     * Add item to Room value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomPriceRes $item
     * @return \ArrayType\ArrayOfRoomPriceRes
     */
    public function addToRoom(\StructType\RoomPriceRes $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomPriceRes) {
            throw new \InvalidArgumentException(sprintf('The Room property can only contain items of \StructType\RoomPriceRes, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Room[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RoomPriceRes|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RoomPriceRes|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RoomPriceRes|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RoomPriceRes|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RoomPriceRes|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Room
     */
    public function getAttributeName()
    {
        return 'Room';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRoomPriceRes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
