<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfString4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfString4 extends AbstractStructArrayBase
{
    /**
     * The HotelFacility
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var string[]
     */
    public $HotelFacility;
    /**
     * Constructor method for ArrayOfString4
     * @uses ArrayOfString4::setHotelFacility()
     * @param string[] $hotelFacility
     */
    public function __construct(array $hotelFacility = array())
    {
        $this
            ->setHotelFacility($hotelFacility);
    }
    /**
     * Get HotelFacility value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string[]|null
     */
    public function getHotelFacility()
    {
        return isset($this->HotelFacility) ? $this->HotelFacility : null;
    }
    /**
     * Set HotelFacility value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param string[] $hotelFacility
     * @return \ArrayType\ArrayOfString4
     */
    public function setHotelFacility(array $hotelFacility = array())
    {
        foreach ($hotelFacility as $arrayOfString4HotelFacilityItem) {
            // validation for constraint: itemType
            if (!is_string($arrayOfString4HotelFacilityItem)) {
                throw new \InvalidArgumentException(sprintf('The HotelFacility property can only contain items of string, "%s" given', is_object($arrayOfString4HotelFacilityItem) ? get_class($arrayOfString4HotelFacilityItem) : gettype($arrayOfString4HotelFacilityItem)), __LINE__);
            }
        }
        if (is_null($hotelFacility) || (is_array($hotelFacility) && empty($hotelFacility))) {
            unset($this->HotelFacility);
        } else {
            $this->HotelFacility = $hotelFacility;
        }
        return $this;
    }
    /**
     * Add item to HotelFacility value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfString4
     */
    public function addToHotelFacility($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The HotelFacility property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelFacility[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelFacility
     */
    public function getAttributeName()
    {
        return 'HotelFacility';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfString4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
