<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'HotelSearchRequest' => '\\StructType\\HotelSearchRequest',
            'ArrayOfRoomGuest' => '\\ArrayType\\ArrayOfRoomGuest',
            'RoomGuest' => '\\StructType\\RoomGuest',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'Filters' => '\\StructType\\Filters',
            'GeoCodes' => '\\StructType\\GeoCodes',
            'AuthenticationData' => '\\StructType\\AuthenticationData',
            'HotelSearchResponse' => '\\StructType\\HotelSearchResponse',
            'ResponseStatus' => '\\StructType\\ResponseStatus',
            'ArrayOfHotel_Result' => '\\ArrayType\\ArrayOfHotel_Result',
            'Hotel_Result' => '\\StructType\\Hotel_Result',
            'HotelInfo' => '\\StructType\\HotelInfo',
            'MinHotelPrice' => '\\StructType\\MinHotelPrice',
            'ArrayOfRooms' => '\\ArrayType\\ArrayOfRooms',
            'Rooms' => '\\StructType\\Rooms',
            'HotelRoomAvailabilityRequest' => '\\StructType\\HotelRoomAvailabilityRequest',
            'HotelRoomAvailabilityResponse' => '\\StructType\\HotelRoomAvailabilityResponse',
            'ArrayOfHotel_Room' => '\\ArrayType\\ArrayOfHotel_Room',
            'Hotel_Room' => '\\StructType\\Hotel_Room',
            'RoomRate' => '\\StructType\\RoomRate',
            'ArrayOfDayRate' => '\\ArrayType\\ArrayOfDayRate',
            'DayRate' => '\\StructType\\DayRate',
            'ArrayOfSupplement' => '\\ArrayType\\ArrayOfSupplement',
            'Supplement' => '\\StructType\\Supplement',
            'RoomInformation' => '\\StructType\\RoomInformation',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'ArrayOfString1' => '\\ArrayType\\ArrayOfString1',
            'CancelPolicies' => '\\StructType\\CancelPolicies',
            'CancelPolicy' => '\\StructType\\CancelPolicy',
            'BookingOptions' => '\\StructType\\BookingOptions',
            'RoomCombination' => '\\StructType\\RoomCombination',
            'HotelCancellationPolicyRequest' => '\\StructType\\HotelCancellationPolicyRequest',
            'HotelCancellationPolicyResponse' => '\\StructType\\HotelCancellationPolicyResponse',
            'ArrayOfString2' => '\\ArrayType\\ArrayOfString2',
            'HotelBookRequest' => '\\StructType\\HotelBookRequest',
            'ArrayOfGuest' => '\\ArrayType\\ArrayOfGuest',
            'Guest' => '\\StructType\\Guest',
            'AddressInfo' => '\\StructType\\AddressInfo',
            'PaymentInfo' => '\\StructType\\PaymentInfo',
            'ArrayOfRequestedRooms' => '\\ArrayType\\ArrayOfRequestedRooms',
            'RequestedRooms' => '\\StructType\\RequestedRooms',
            'Rate' => '\\StructType\\Rate',
            'ArrayOfSuppInfo' => '\\ArrayType\\ArrayOfSuppInfo',
            'SuppInfo' => '\\StructType\\SuppInfo',
            'ArrayOfSpecialRequest' => '\\ArrayType\\ArrayOfSpecialRequest',
            'SpecialRequest' => '\\StructType\\SpecialRequest',
            'HotelBookResponse' => '\\StructType\\HotelBookResponse',
            'PriceChangeStatus' => '\\StructType\\PriceChangeStatus',
            'AvailabilityAndPricingRequest' => '\\StructType\\AvailabilityAndPricingRequest',
            'AvailabilityAndPricingResponse' => '\\StructType\\AvailabilityAndPricingResponse',
            'HotelCancellationPolicies' => '\\StructType\\HotelCancellationPolicies',
            'PriceVerification' => '\\StructType\\PriceVerification',
            'AccountInfo' => '\\StructType\\AccountInfo',
            'HotelDetailsVerification' => '\\StructType\\HotelDetailsVerification',
            'APIHotelDetails' => '\\StructType\\APIHotelDetails',
            'ArrayOfString3' => '\\ArrayType\\ArrayOfString3',
            'ArrayOfString4' => '\\ArrayType\\ArrayOfString4',
            'ArrayOfString5' => '\\ArrayType\\ArrayOfString5',
            'ArrayOfRoomInfo' => '\\ArrayType\\ArrayOfRoomInfo',
            'RoomInfo' => '\\StructType\\RoomInfo',
            'ArrayOfString6' => '\\ArrayType\\ArrayOfString6',
            'ArrayOfString7' => '\\ArrayType\\ArrayOfString7',
            'HotelBookingDetailRequest' => '\\StructType\\HotelBookingDetailRequest',
            'HotelBookingDetailResponse' => '\\StructType\\HotelBookingDetailResponse',
            'APIBookingDetail' => '\\StructType\\APIBookingDetail',
            'ArrayOfRoomDetails' => '\\ArrayType\\ArrayOfRoomDetails',
            'RoomDetails' => '\\StructType\\RoomDetails',
            'ArrayOfSupp_info' => '\\ArrayType\\ArrayOfSupp_info',
            'Supp_info' => '\\StructType\\Supp_info',
            'AmendmentDetails' => '\\StructType\\AmendmentDetails',
            'AgencyDetails' => '\\StructType\\AgencyDetails',
            'AOTNumbers' => '\\StructType\\AOTNumbers',
            'GenerateInvoiceRequest' => '\\StructType\\GenerateInvoiceRequest',
            'GenerateInvoiceResponse' => '\\StructType\\GenerateInvoiceResponse',
            'AmendmentRequest' => '\\StructType\\AmendmentRequest',
            'AmendmentRequestType' => '\\StructType\\AmendmentRequestType',
            'AmendInformation' => '\\StructType\\AmendInformation',
            'CheckInReq' => '\\StructType\\CheckInReq',
            'CheckOutReq' => '\\StructType\\CheckOutReq',
            'ArrayOfRoomReq' => '\\ArrayType\\ArrayOfRoomReq',
            'RoomReq' => '\\StructType\\RoomReq',
            'AmendGuestReq' => '\\StructType\\AmendGuestReq',
            'AmendmentResponse' => '\\StructType\\AmendmentResponse',
            'ApprovalInformation' => '\\StructType\\ApprovalInformation',
            'ArrayOfRoomPriceRes' => '\\ArrayType\\ArrayOfRoomPriceRes',
            'RoomPriceRes' => '\\StructType\\RoomPriceRes',
            'TotalPrice' => '\\StructType\\TotalPrice',
            'AmendmentRequested' => '\\StructType\\AmendmentRequested',
            'CheckInRes' => '\\StructType\\CheckInRes',
            'CheckOutRes' => '\\StructType\\CheckOutRes',
            'ArrayOfRoomRes' => '\\ArrayType\\ArrayOfRoomRes',
            'RoomRes' => '\\StructType\\RoomRes',
            'AmendGuestRes' => '\\StructType\\AmendGuestRes',
            'HotelCancelRequest' => '\\StructType\\HotelCancelRequest',
            'HotelCancelResponse' => '\\StructType\\HotelCancelResponse',
            'CountryListRequest' => '\\StructType\\CountryListRequest',
            'CountryListResponse' => '\\StructType\\CountryListResponse',
            'ArrayOfCountryList' => '\\ArrayType\\ArrayOfCountryList',
            'CountryList' => '\\StructType\\CountryList',
            'DestinationCityListRequest' => '\\StructType\\DestinationCityListRequest',
            'DestinationCityListResponse' => '\\StructType\\DestinationCityListResponse',
            'ArrayOfCityList' => '\\ArrayType\\ArrayOfCityList',
            'CityList' => '\\StructType\\CityList',
            'TopDestinationsRequest' => '\\StructType\\TopDestinationsRequest',
            'TopDestinationsResponse' => '\\StructType\\TopDestinationsResponse',
            'HotelDetailsRequest' => '\\StructType\\HotelDetailsRequest',
            'HotelDetailsResponse' => '\\StructType\\HotelDetailsResponse',
            'HotelCodesRequest' => '\\StructType\\HotelCodesRequest',
            'HotelCodesResponse' => '\\StructType\\HotelCodesResponse',
            'ArrayOfHotels' => '\\ArrayType\\ArrayOfHotels',
            'Hotels' => '\\StructType\\Hotels',
            'HotelSearchWithRoomsRequest' => '\\StructType\\HotelSearchWithRoomsRequest',
            'HotelSearchWithRoomsFilters' => '\\StructType\\HotelSearchWithRoomsFilters',
            'HotelSearchWithRoomsResponse' => '\\StructType\\HotelSearchWithRoomsResponse',
            'ArrayOfHotel_ResultWithRooms' => '\\ArrayType\\ArrayOfHotel_ResultWithRooms',
            'Hotel_ResultWithRooms' => '\\StructType\\Hotel_ResultWithRooms',
            'HotelBookingDetailBasedOnDateRequest' => '\\StructType\\HotelBookingDetailBasedOnDateRequest',
            'HotelBookingDetailBasedOnDateResponse' => '\\StructType\\HotelBookingDetailBasedOnDateResponse',
            'ArrayOfBookingsBasedOnDate' => '\\ArrayType\\ArrayOfBookingsBasedOnDate',
            'BookingsBasedOnDate' => '\\StructType\\BookingsBasedOnDate',
            'GiataHotelCodesRequest' => '\\StructType\\GiataHotelCodesRequest',
            'GiataHotelCodesResponse' => '\\StructType\\GiataHotelCodesResponse',
            'ArrayOfGiataHotels' => '\\ArrayType\\ArrayOfGiataHotels',
            'GiataHotels' => '\\StructType\\GiataHotels',
            'ArrayOfAPIHotelDetails' => '\\ArrayType\\ArrayOfAPIHotelDetails',
            'TagInfoRequest' => '\\StructType\\TagInfoRequest',
            'TagInfoResponse' => '\\StructType\\TagInfoResponse',
            'ArrayOfTagInfos' => '\\ArrayType\\ArrayOfTagInfos',
            'TagInfos' => '\\StructType\\TagInfos',
            'CityWiseNotificationRequest' => '\\StructType\\CityWiseNotificationRequest',
            'CityWiseNotificationResponse' => '\\StructType\\CityWiseNotificationResponse',
            'ArrayOfCityWiseNotification' => '\\ArrayType\\ArrayOfCityWiseNotification',
            'CityWiseNotification' => '\\StructType\\CityWiseNotification',
        );
    }
}
