<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AmendInformation StructType
 * @subpackage Structs
 */
class AmendInformation extends AbstractStructBase
{
    /**
     * The CheckIn
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CheckInReq
     */
    public $CheckIn;
    /**
     * The CheckOut
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\CheckOutReq
     */
    public $CheckOut;
    /**
     * The Rooms
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfRoomReq
     */
    public $Rooms;
    /**
     * Constructor method for AmendInformation
     * @uses AmendInformation::setCheckIn()
     * @uses AmendInformation::setCheckOut()
     * @uses AmendInformation::setRooms()
     * @param \StructType\CheckInReq $checkIn
     * @param \StructType\CheckOutReq $checkOut
     * @param \ArrayType\ArrayOfRoomReq $rooms
     */
    public function __construct(\StructType\CheckInReq $checkIn = null, \StructType\CheckOutReq $checkOut = null, \ArrayType\ArrayOfRoomReq $rooms = null)
    {
        $this
            ->setCheckIn($checkIn)
            ->setCheckOut($checkOut)
            ->setRooms($rooms);
    }
    /**
     * Get CheckIn value
     * @return \StructType\CheckInReq|null
     */
    public function getCheckIn()
    {
        return $this->CheckIn;
    }
    /**
     * Set CheckIn value
     * @param \StructType\CheckInReq $checkIn
     * @return \StructType\AmendInformation
     */
    public function setCheckIn(\StructType\CheckInReq $checkIn = null)
    {
        $this->CheckIn = $checkIn;
        return $this;
    }
    /**
     * Get CheckOut value
     * @return \StructType\CheckOutReq|null
     */
    public function getCheckOut()
    {
        return $this->CheckOut;
    }
    /**
     * Set CheckOut value
     * @param \StructType\CheckOutReq $checkOut
     * @return \StructType\AmendInformation
     */
    public function setCheckOut(\StructType\CheckOutReq $checkOut = null)
    {
        $this->CheckOut = $checkOut;
        return $this;
    }
    /**
     * Get Rooms value
     * @return \ArrayType\ArrayOfRoomReq|null
     */
    public function getRooms()
    {
        return $this->Rooms;
    }
    /**
     * Set Rooms value
     * @param \ArrayType\ArrayOfRoomReq $rooms
     * @return \StructType\AmendInformation
     */
    public function setRooms(\ArrayType\ArrayOfRoomReq $rooms = null)
    {
        $this->Rooms = $rooms;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AmendInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
