<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ApprovalInformation StructType
 * @subpackage Structs
 */
class ApprovalInformation extends AbstractStructBase
{
    /**
     * The Rooms
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfRoomPriceRes
     */
    public $Rooms;
    /**
     * The TotalPrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\TotalPrice
     */
    public $TotalPrice;
    /**
     * Constructor method for ApprovalInformation
     * @uses ApprovalInformation::setRooms()
     * @uses ApprovalInformation::setTotalPrice()
     * @param \ArrayType\ArrayOfRoomPriceRes $rooms
     * @param \StructType\TotalPrice $totalPrice
     */
    public function __construct(\ArrayType\ArrayOfRoomPriceRes $rooms = null, \StructType\TotalPrice $totalPrice = null)
    {
        $this
            ->setRooms($rooms)
            ->setTotalPrice($totalPrice);
    }
    /**
     * Get Rooms value
     * @return \ArrayType\ArrayOfRoomPriceRes|null
     */
    public function getRooms()
    {
        return $this->Rooms;
    }
    /**
     * Set Rooms value
     * @param \ArrayType\ArrayOfRoomPriceRes $rooms
     * @return \StructType\ApprovalInformation
     */
    public function setRooms(\ArrayType\ArrayOfRoomPriceRes $rooms = null)
    {
        $this->Rooms = $rooms;
        return $this;
    }
    /**
     * Get TotalPrice value
     * @return \StructType\TotalPrice|null
     */
    public function getTotalPrice()
    {
        return $this->TotalPrice;
    }
    /**
     * Set TotalPrice value
     * @param \StructType\TotalPrice $totalPrice
     * @return \StructType\ApprovalInformation
     */
    public function setTotalPrice(\StructType\TotalPrice $totalPrice = null)
    {
        $this->TotalPrice = $totalPrice;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ApprovalInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
