<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GiataHotelCodesResponse StructType
 * @subpackage Structs
 */
class GiataHotelCodesResponse extends AbstractStructBase
{
    /**
     * The Status
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ResponseStatus
     */
    public $Status;
    /**
     * The Hotels
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfGiataHotels
     */
    public $Hotels;
    /**
     * The HotelDetails
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfAPIHotelDetails
     */
    public $HotelDetails;
    /**
     * Constructor method for GiataHotelCodesResponse
     * @uses GiataHotelCodesResponse::setStatus()
     * @uses GiataHotelCodesResponse::setHotels()
     * @uses GiataHotelCodesResponse::setHotelDetails()
     * @param \StructType\ResponseStatus $status
     * @param \ArrayType\ArrayOfGiataHotels $hotels
     * @param \ArrayType\ArrayOfAPIHotelDetails $hotelDetails
     */
    public function __construct(\StructType\ResponseStatus $status = null, \ArrayType\ArrayOfGiataHotels $hotels = null, \ArrayType\ArrayOfAPIHotelDetails $hotelDetails = null)
    {
        $this
            ->setStatus($status)
            ->setHotels($hotels)
            ->setHotelDetails($hotelDetails);
    }
    /**
     * Get Status value
     * @return \StructType\ResponseStatus|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param \StructType\ResponseStatus $status
     * @return \StructType\GiataHotelCodesResponse
     */
    public function setStatus(\StructType\ResponseStatus $status = null)
    {
        $this->Status = $status;
        return $this;
    }
    /**
     * Get Hotels value
     * @return \ArrayType\ArrayOfGiataHotels|null
     */
    public function getHotels()
    {
        return $this->Hotels;
    }
    /**
     * Set Hotels value
     * @param \ArrayType\ArrayOfGiataHotels $hotels
     * @return \StructType\GiataHotelCodesResponse
     */
    public function setHotels(\ArrayType\ArrayOfGiataHotels $hotels = null)
    {
        $this->Hotels = $hotels;
        return $this;
    }
    /**
     * Get HotelDetails value
     * @return \ArrayType\ArrayOfAPIHotelDetails|null
     */
    public function getHotelDetails()
    {
        return $this->HotelDetails;
    }
    /**
     * Set HotelDetails value
     * @param \ArrayType\ArrayOfAPIHotelDetails $hotelDetails
     * @return \StructType\GiataHotelCodesResponse
     */
    public function setHotelDetails(\ArrayType\ArrayOfAPIHotelDetails $hotelDetails = null)
    {
        $this->HotelDetails = $hotelDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GiataHotelCodesResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
